﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Runtime.InteropServices;

namespace PLDAAPINet
{
    /// <summary>
    /// Class PLDAAPI which manages Function Declartions
    /// </summary>
    public class PLDAAPI
    {
        

        public enum CtrlTypes
        {
            CTRL_C_EVENT = 0,
            CTRL_BREAK_EVENT = 1,
            CTRL_CLOSE_EVENT = 2,
            CTRL_LOGOFF_EVENT = 5,
            CTRL_SHUTDOWN_EVENT = 6
        }

        public delegate bool HandlerRoutine(CtrlTypes CtrlType);

        [DllImport("kernel32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        public static extern IntPtr CreateEvent(IntPtr lpEventAttributes, bool bManualReset, bool bInitialState, string lpName);

        /*[DllImport("kernel32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        public static extern IntPtr CreateEvent(IntPtr lpEventAttributes, [In, MarshalAs(UnmanagedType.Bool)] bool bManualReset, [In, MarshalAs(UnmanagedType.Bool)] bool bIntialState, [In, MarshalAs(UnmanagedType.BStr)] string lpName);*/

        [DllImport("kernel32.dll", SetLastError = true)]
        public static extern bool SetConsoleCtrlHandler(HandlerRoutine Handler, bool Add);

        [DllImport("msvcrt.dll", EntryPoint = "memset", CallingConvention = CallingConvention.Cdecl, SetLastError = false)]
        public static extern IntPtr MemSet(IntPtr dest, int c, int byteCount);

        [DllImport("kernel32.dll")]
        public static extern bool SetEvent(IntPtr hEvent);

        [DllImport("kernel32.dll", SetLastError = true)]
        public static extern UInt32 WaitForSingleObject(IntPtr hHandle, UInt32 dwMilliseconds);
        /**************************************************************************************************************************/
        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern bool Creating_ISR_Event();

        [DllImport("PLDA.dll", CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr WakeThreadEventHandle(UInt32 DeviceIndex);

        [DllImport("PLDA.dll", CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr IRQ_EventHandle(UInt32 DeviceIndex);

        [DllImport("PLDA.dll", CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 IntStatus();

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 Get_Target_Hz();

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 FIFO_THRESHOLD_VALUE();

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 DMA_ENABLE_ACQ();

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 InitializeInterrupt(UInt32 PCIAgentIndex, ref structure.SPCIInterruptTransfer pPCIInterruptTransfer);
        /********************************************Driver Initialization********************************************************/
        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaInitDriver();

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaInitDriverFilter(UInt32 vendor_id, UInt32 device_id);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaClearDriver();

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaGetAPIVer(StringBuilder strVer);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaGetDrvVer(StringBuilder strVer);

        /*********************************************************Driver Access*****************************************************/

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaGetPCIAgentCount(ref UInt32 pPCIAgentCount);


        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaGetPCIAgentID(UInt32 PCIAgentIndex, ref structure.SPCISlotDescription pPCISlotDescription);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaLockResources(UInt32 PCIAgentIndex);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaClearResources(UInt32 PCIAgentIndex);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaGetPCIAgentResources(UInt32 PCIAgentIndex, ref structure.SPCIResources pPCIResources);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaGetConfigRegister(UInt32 PCIAgentIndex, UInt32 ByteOffset, ref UInt32 pReadConfigRegister);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaSetConfigRegister(UInt32 PCIAgentIndex, UInt32 ByteOffset, IntPtr pWriteConfigRegister);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaGetConfigHeader(UInt32 PCIAgentIndex, ref structure.SPCIConfigHeader0 pPCIConfigHeader0);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaGetConfigStatus(UInt32 PCIAgentIndex, structure.SPCIConfigStatus pPCIConfigStatus);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaGetConfigCommand(UInt32 PCIAgentIndex, structure.SPCIConfigCommand pPCIConfigCommand);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaMemoryRead32(UInt32 PCIAgentIndex, UInt32 BarIndex, UInt32 dwOffset, UInt32 dwSize, ref UInt32 pRdBuffer);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaMemoryWrite32(UInt32 PCIAgentIndex, UInt32 BarIndex, UInt32 dwOffset, UInt32 dwSize, UInt32[] pWrBuffer);

        //For DMA/************************************************************
        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static unsafe extern UInt32 PldaMemoryWrite32(UInt32 PCIAgentIndex, UInt32 BarIndex, UInt32 dwOffset, UInt32 dwSize, UInt32* pWrBuffer);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 Event_handling(UInt32 iBoard);
        //********************************************************************

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaLockPhysicalAddress(UInt32 PCIAgentIndex, IntPtr DMABufferIndex, structure.SBufferDescription pBufferDescription);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaGetPhysicalAddress(UInt32 PCIAgentIndex, UInt32 DMABufferIndex, structure.SBufferDescription pBufferDescription);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaReleasePhysicalAddress(UInt32 PCIAgentIndex, UInt32 DMABufferIndex);
        
        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern unsafe UInt32 PldaSGMemLock(UInt32 PCIAgentIndex, UInt32* bufferIndex, structure.SSGBufferDescription* pBufferDescription);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaSGMemUnlock(UInt32 PCIAgentIndex, UInt32 bufferIndex);

        [DllImport("PLDA.dll", CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl)] //CharSet = CharSet.Ansi
        public static extern   UInt32 PldaInitializeInterrupt(UInt32 PCIAgentIndex,  ref structure.SPCIInterruptTransfer pPCIInterruptTransfer, IntPtr Phandler);

        [DllImport("PLDA.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern UInt32 PldaReleaseInterrupt(UInt32 PCIAgentIndex);
 

    }
}
