﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;


namespace PLDAAPINet
{
    public class structure
    {


        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct SECURITY_ATTRIBUTES
        {
            public int length;
            public IntPtr securityDesc;
            public bool inherit;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct SPCISlotDescription
        {
            public UInt32 VendorID;
            public UInt32 DeviceID;
            public UInt32 BusID;
            public UInt32 DevID;
            public UInt32 FctID;
        };

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public unsafe struct SPCIResources
        {
            public bool fIsInitialized;
            //[MarshalAs(UnmanagedType.LPArray, ArraySubType = UnmanagedType.I1)]
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public bool[] BARIsActive;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public bool[] BARIsMemory;

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public UInt64[] BARPhysicalAddress;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public UInt64[] BARKernAddress;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public UInt64[] BARUserAddress;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public UInt32[] BARLength;

            public UInt32 hInterrupt;
            public void* hThread;
            public UInt32 IntCount;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct SBufferDescription
        {
            public UInt32 ByteCount;
            public UInt64 UserAddr;
            public UInt64 PhysicalAddr;
            public UInt64 KernelAddr;
        };

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        unsafe public struct SSGBufferDescription
        {
            public void* UserAddr;
            public UInt32 ByteCount;
            public UInt32 DescAddrLow;
            public UInt32 DescAddrHigh;
        };

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct SPCIInterruptTransfer
        {
            public UInt32 AccessType;
            public UInt32 BarIndex;
            public UInt32 ByteOffset;
            public UInt32 ResetValue;
            public UInt32 Ulmask; /* Use to identify the interrupt in case of a shared interrupt */
            public UInt32 UlInterruptType; /* pin-based, MSI or MSI-X */
            public UInt32 Uinbvec; /* in/out : numer of message requested/allocated */

            /* Internal use */
            //	UINT32 OperationPendingBarIndex;
            //	UINT32 OperationPendingByteOffset;
            //	UINT32 OperationPendingCondition;
            //	UINT32 OperationPendingCheckEnabled;
            //	UINT32 OperationPendingCheckForEquality;

        };
        [StructLayout(LayoutKind.Sequential)]
        public struct SPCIInterruptData
        {

            public UInt32 Data;    /* interrupt register content */
            public UInt32 Irq_count;/* Number of interrupt received */
            public UInt32 ISlot;   /* SLOT ID  */
            public UInt32 IBoard;  /* board index */
        };

        //public UInt32[] BaseAddress = new UInt32[6];
        //public UInt32[] Reserved = new UInt32[2];
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
        public struct SPCIConfigHeader0
        {
            public ushort VendorID;
            public ushort DeviceID;
            public ushort Command;
            public ushort Status;
            public byte RevisionID;
            public byte ProgIf;
            public byte SubClass;
            public byte BaseClass;
            public byte CacheLineSize;
            public byte LatencyTimer;
            public byte HeaderType;
            public byte Bist;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public UInt32[] BaseAddress;
            public UInt32 CardBusCISPtr;
            public ushort SubsystemVendorID;
            public ushort SubsystemID;
            public UInt32 ROMBaseAddress;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
            public UInt32[] Reserved2;
            public byte InterruptLine;
            public byte InterruptPin;
            public byte MinimumGrant;
            public byte MaximumLatency;
        };

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct SPCIConfigStatus
        {
            public bool DetectedParityError;
            public bool SignalledSystemError;
            public bool ReceivedMasterAbort;
            public bool ReceivedTargetAbort;
            public bool SignalledTargetAbort;
            public UInt32 DevselTiming;
            public bool DataParityReported;
            public bool FastBackToBackCapable;
            public bool UdfSupported;
            public bool F66MhzCapable;
            public bool CapabilitiesList;
            public bool InterruptStatus;
        };
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct SPCIConfigCommand
        {
            public bool InterruptDisable;
            public bool FastBackToBackEnable;
            public bool SerrEnable;
            public bool WaitCycleControl;
            public bool ParityErrorResponse;
            public bool PaletteSnoopEnable;
            public bool MemoryWriteAndInvalidateEnable;
            public bool SpecialCycleMonitoring;
            public bool EnableMastering;
            public bool MemoryAccessEnable;
            public bool IoAccessEnable;
        };

    }
}
